#ifndef SQUINEWAVE_HPP_INCLUDED
#define SQUINEWAVE_HPP_INCLUDED

// Inlets: Freq, Clip, Skew, Sync
// Output: Audio, Sync
class Squinewave
{

public:

	Squinewave() {}

	~Squinewave() {}


public:
	void generate(double* output, const long count);

	void hardsync_now() { hardsync_init(get_freq(0)); }

public:
    // Consts inited from environment
	double  framerate = 44100;  // Inited by owner

    double  Min_Sweep = 13.0;
    double  Max_Warp = 1.0 / Min_Sweep;
    double  Maxphase_By_sr = 2.0 / framerate;
    double  Max_Warp_Freq = framerate / Min_Sweep;

private:
	void hardsync_init(const double freq);

    // phase and warped_phase range 0-2. This makes skew/clip into simple proportions
    double  phase;
    double  warped_phase;
    double  hardsync_phase;
    double  hardsync_inc;

public:
	// Inputs are arrays of same length as requested output (if they are in use).
	double* freq_sig_in = nullptr;
	double* clip_sig_in = nullptr;
	double* skew_sig_in = nullptr;
	double* sync_sig_in = nullptr;
	double* sync_sig_out = nullptr;

	double get_freq(int n) const { return freq_sig_in ? freq_sig_in[n] : 0; }
	double get_skew(int n) const { return skew_sig_in ? skew_sig_in[n] : 0; }
	double get_clip(int n) const { return clip_sig_in ? clip_sig_in[n] : 0; }
};


#endif  // SQUINEWAVE_HPP_INCLUDED
